checkRequire("Lua_Cus_SerItem")
Lua_Cus_SerPanel = class("Lua_Cus_SerPanel", Lua_DisplayObject);
function Lua_Cus_SerPanel:ctor(p)
	self:superCall("ctor", p, "Cus_SerPanel_skin");    
end

function Lua_Cus_SerPanel:buildShowItem()
	self:superCall("buildShowItem");

	DataCenter.cur_serData:sOpenPanel()
	local btnInterchange = Array();
	btnInterchange:add({name=LanUtil.getValue(120600)});
	btnInterchange:add({name=LanUtil.getValue(120601), eventIds = { 10088 }});

	self.cus_serList = Lua_ButtonList.new(self.content, btnInterchange, 80, self, self.onButtonListClick,
		"tab4_souchong_normal", "tab4_souchong_select", Vector4(0, 0, 170, 62), Vector4(0, 0, 180, 72),
		Lua_ColorDefine.transColor("192e41"), Lua_ColorDefine.transColor("883a0b"), Vector4(24, 26, 120, 30), 1);
    self.cus_serList:setLocation(-523,239,0);
	self.cus_serList:setDepth(5);
	self.cus_serList:setSelected(1, false);
	self.cus_serList:setRedDotPos(72, 13)
	--self.cus_serList:setRedDotStateByIndex(2, false)

	self.Question.gameObject:SetActive(true)
	self.Answer.gameObject:SetActive(false)

	self:questionBoardInit()

	self.ansDragList = Lua_DragList.new(self.content,1, Vector4(-485, -233, 380, 596));
	self.ansDragList:setLocation(225, 214, 0);
	self.ansDragList:setDepth(5000)
	self.ansDragList:setListCell(Lua_Cus_SerItem, 165, 385, 1);

	-- self.redDotImg = UICreate.createUIAtlasImage(self.content, "iconantlas4", "redDot", 0, 32, 0, 0);
	-- self.redDotImg:setDepth(15);
	-- self.redDotImg.name = "redDotImg"
	-- self.redDotImg:setLocation(-453, 169)
	-- local isShow = DataCenter.redDotData:getRedDotStateByEventId(10088);
	-- self.redDotImg:setEnable(isShow)


	self.rd = DataCenter.cur_serData

	-- if self.rd.recordList:getSize() > 0 then
    --     self:setSelected(self.rd.recordList[1]);
    -- end

	self:addLuaEvent("OPEN_PANEL", self, self.openPanel)
	self:addLuaEvent("RECORD_CELL_CLICK", self, self.setSelected)
	self:addLuaEvent("REPLY_LABEL", self, self.updateFunction)
	--self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDotTips);

	self.deleteBtn:addClickFuntion(self, self.onDeleteRecordClick);
	self.ansDragList:setEnable(false)
end

function Lua_Cus_SerPanel:onButtonListClick(val)
	self.Question.gameObject:SetActive(val == 1)
	self.Answer.gameObject:SetActive(val == 2)
	self.ansDragList:setEnable(val == 2)
	if val == 2 then
		DataCenter.cur_serData:sCustomerSVCRecord();
	end
end

function Lua_Cus_SerPanel:openPanel(obj)
	if obj == nil then
		self.titleInput.text = ""
		self.detailInput.text = ""		
	else
		self.titleInput.text = obj.title
		self.detailInput.text = obj.content

		if obj.last_record_type == 1 then
			self.typeChk1.seleted = true
			self.typeChk2.seleted = false
			self.typeChk2.seleted = false
		elseif obj.last_record_type == 2 then
			self.typeChk1.seleted = false
			self.typeChk2.seleted = true
			self.typeChk3.seleted = false
		elseif obj.last_record_type == 3 then
			self.typeChk1.seleted = false
			self.typeChk2.seleted = false
			self.typeChk3.seleted = true
		elseif obj.last_record_type == 4 then
			self.typeChk1.seleted = false
			self.typeChk2.seleted = false
			self.typeChk3.seleted = false
		end

		self.cur_serContactLabel.text = LanUtil.getValue(120617)
		self.cur_serContactText.text = obj.contact
	end
end


--初始化提问面板
function Lua_Cus_SerPanel:questionBoardInit()
	self.titleInput.characterLimit = 20 
	self.detailInput.characterLimit = 200
 	
 	self.cur_serContactLabel.text = LanUtil.getValue(120617)

 	self.submitBtn:addClickFuntion(self, self.onSubmitClick)


 	self.typeChk1:addBoxChange(self, self.onType_1_BoxClick)
 	self.typeChk2:addBoxChange(self, self.onType_2_BoxClick)
 	self.typeChk3:addBoxChange(self, self.onType_3_BoxClick)


	self.typeChk1.seleted = true
	self.typeChk2.seleted = false
	self.typeChk3.seleted = false
	self.typeState = 1

	self.noteTxt.text = LanUtil.getValue(120610);
end

function Lua_Cus_SerPanel:updateFunction()
	if self.selectedRecordId ~= 0 then
        local curRecordData = self.rd:getRecordByRecord_Id(self.selectedRecordId);
        if curRecordData ~= nil then
            self:setSelected(curRecordData);
            self.deleteBtn:setBtnEnable(true)            
        else
            if self.rd.recordList:getSize() > 0 then
                self:setSelected(self.rd.recordList[1]);
                self.deleteBtn:setBtnEnable(true)
            else
            	self.queTxt.text = ""
            	self.ansTxt.text = ""
            	self.deleteBtn:setBtnEnable(false)
                self.ansDragList:setLuaArrayData(self.rd.recordList);
            end
        end
	end
end

function Lua_Cus_SerPanel:setSelected(val)
	local len = self.rd.recordList:getSize();
    for i=1,len do
		self.rd.recordList[i].selected = self.rd.recordList[i].record_id == val.record_id;
		if self.rd.recordList[i].record_id == val.record_id and self.rd.recordList[i].record_status==1 then
			self.rd.recordList[i].record_read_status=1;
		end
    end
	self.ansDragList:setLuaArrayData(self.rd.recordList);
    DataCenter.cur_serData:sReadSerReply(val.record_id)
    self.selectedRecordId = val.record_id;

    self.queTxt.text = self.rd:getRecordByRecord_Id(val.record_id).content
    self.ansTxt.text = self.rd:getRecordByRecord_Id(val.record_id).replay_content
end

function Lua_Cus_SerPanel:onType_1_BoxClick(state)
	if state == true then
		self.typeChk2.seleted = false
		self.typeChk3.seleted = false
		self.typeState = 1
	else
		self.typeState = 4
	end
end

function Lua_Cus_SerPanel:onType_2_BoxClick(state)
	if state == true then
		self.typeChk1.seleted = false
		self.typeChk3.seleted = false
		self.typeState = 2
	else
		self.typeState = 4
	end
end

function Lua_Cus_SerPanel:onType_3_BoxClick(state)
	if state == true then
		self.typeChk1.seleted = false
		self.typeChk2.seleted = false
		self.typeState = 3
	else
		self.typeState = 4
	end
end

function Lua_Cus_SerPanel:onSubmitClick(obj)
	if self.titleInput.text == "" and self.detailInput.text == "" then
		OperateAlert.show(LanUtil.getValue(120605));
		return;
	end

	if self.titleInput.text == "" then
		OperateAlert.show(LanUtil.getValue(120615));
		return;
	elseif self.detailInput.text == "" then
		OperateAlert.show(LanUtil.getValue(120616));
		return;
	end

	local commitData = {};
	commitData.des = LanUtil.getValue(120611)
	commitData.owner = self;
	commitData.type = 1;
	commitData.subFun = self.onCommitClick;   --提交
	commitData.cancelFun = self.onSaveClick;     --保存
	commitData.subName = LanUtil.getValue(120612)
	commitData.cancelName = LanUtil.getValue(120613)

	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, commitData);
end

function Lua_Cus_SerPanel:onCommitClick()
	self:sendQuestion(1);
end

function Lua_Cus_SerPanel:onSaveClick()
	self:sendQuestion(0);
end

--提交问题
function Lua_Cus_SerPanel:sendQuestion(state)
	local msg = ProtoPublic_pb.Proto10100903();

	if self.titleInput.text ~= "" and self.detailInput.text ~= "" then
		msg.title = self.titleInput.text
		msg.content = self.detailInput.text;
		
		msg.record_type = self.typeState

		msg.is_summit = state
		sendMsg(10100903, msg)
		print(msg.title.."   "..msg.content.."   "..msg.record_type.."  "..msg.is_summit.."   提交成功")
	end
end

function Lua_Cus_SerPanel:onDeleteRecordClick(go)
	DataCenter.cur_serData:sDeleteSerReply(self.selectedRecordId)
end
function Lua_Cus_SerPanel:updateRedDotTips(obj)
	if tonumber(obj.evenId) == 10088 then
		if tonumber(obj.val) > 0 then
			self.redDotImg:setEnable(true)
		else
			self.redDotImg:setEnable(false)
		end
	end
end