checkRequire("Lua_FriendItem");
checkRequire("Lua_ChatDragContainer");
Lua_FriendPanel = class("Lua_FriendPanel", Lua_DisplayObject);
function Lua_FriendPanel:ctor(p)
	self:superCall("ctor", p, "FriendPanel_skin");
end

function Lua_FriendPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.faceBtn:addClickFuntion(self,self.onFaceClick);
	self:addLuaEvent("FRIEND_SENDNEW_DATA",self,self.onSendNewData);

	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateFriendRequestTips);
	self:addLuaEvent("UPDATE_FRIEND_REDDOT", self, self.updateGroudRedDot);
	self:addLuaEvent("ON_FRIEND_DATA",self,self.rFriendData);
	self:addLuaEvent("UPDATE_PRIVATE_MSG",self,self.onUpdateChatMsg);

	self.addBtn:addClickFuntion(self,self.onAddClick);
	self.huaBtn:addClickFuntion(self,self.onHuaClick);
	self.shenqingBtn:addClickFuntion(self,self.onShenQingClick);
	self.subBtn:addClickFuntion(self, self.onSendPrivateChat);

	self.soundBtn:addClickFuntion(self, self.onSoundClick);
	self.soundBtn:addMouseUpFuntion(self, self.onSoundUpClick);
	self:addCSharpEvent("VOICE_DONE", self, self.onVoiceDown);

	if getShowTips() == false or getLanType() == 1 then
    	self.soundBtn:setEnable(false);
	end

	self.defaultMsg = LanUtil.getValue(120207);
	self.msgText.defaultText = self.defaultMsg;
	self.msgText.text = "";
	self.talkTxt.text = LanUtil.getValue(120213);
	self.nameList=Array()
	self.nameList:add(LanUtil.getValue(120107));
	self.nameList:add(LanUtil.getValue(120108));
	self.nameList:add(LanUtil.getValue(120109));
	self.nameList:add(LanUtil.getValue(120110));
	DataCenter.friendData:sFriendList(0);

	self.typeList = Lua_DragTitleList.new(self.content, 360, 560, Lua_FriendItem, 360, 100); 
	self.typeList:setLocation(-423, 235, 0);
  

	local isShow = DataCenter.redDotData:getRedDotStateByEventId(10008);
	self.redSp.uiwidget.gameObject:SetActive(isShow);
	self.redSp:SetDimensions(20, 20);

	self.lastSendTime = 0;
	self.dragChatContainer = Lua_ChatDragContainer.new(self.content,1, Vector4(300, -218, 660, 470), 590, true);
	self.dragChatContainer:setLocation(-165,206,0);

	local len = DataCenter.chatData.maxMsgLen;
	self.msgText.characterLimit = len;
end

function Lua_FriendPanel:showDefaultData(data)
	local fdata = DataCenter.friendData:getFriendData(tonumber(data));
	self.defaultSelectedFData = {data=fdata.info,type=2,name=fdata.info.name};
end

function Lua_FriendPanel:onUpdateChatMsg(val)
  if self.selectedData == nil then
    self.dragChatContainer:updateChatList(nil);
    return;
  end
  if val == nil or val == tonumber(self.selectedData.data.role_id) then
    local rid = tonumber(self.selectedData.data.role_id);
    local list = DataCenter.chatData:getPrivateMsgList(rid);
    self.dragChatContainer:updateChatList(list);
  else
    self.dragChatContainer:updateChatList(nil);
  end
end

function Lua_FriendPanel:onSendPrivateChat(go)
  if self.selectedData == nil then
    OperateAlert.show(LanUtil.getValue(120215));
    return;
  end
  local str = self.msgText.text;
  if self.defaultMsg == str or string.len(str) == 0 then
    OperateAlert.show(LanUtil.getValue(120216));
    return;
  end
  self.lastSendTime = getTime();
  if DataCenter.roleData.permission == 8 then
    local rs = str;
    if getCVersion() > 1230 then
      ChatUtil.sendPrivateMsg(Lua_CommonUtil.trnsLongNum(self.selectedData.data.role_id), rs, false);
    else
      ChatUtil.sendPrivateMsg(Lua_CommonUtil.trnsLongNum(self.selectedData.data.role_id), rs);
    end
  else
    local rs = Lua_ChatUtil.replaceChatMsg(str);
    local canSend = Lua_ChatUtil.checkSendMsg(rs);
    if canSend == 1 or canSend == 2 then
      OperateAlert.show(LanUtil.getValue(120231));
    else
      ChatUtil.sendPrivateMsg(Lua_CommonUtil.trnsLongNum(self.selectedData.data.role_id), rs);
    end
  end
  self.msgText.defaultText = self.defaultMsg;
  self.msgText.text = "";
  self.msgText.maxLineCount = 1;
end

function Lua_FriendPanel:rFriendData()
  self:setItemData();
  self.typeList:setDepth(5);
  self:setTypeListRedDot();
  if self.typeList.selectedVal~= nil and self.arr[self.typeList.selectedVal] ~= nil and self.arr[self.typeList.selectedVal].sub~=nil then
   self.typeList:setSelected(self.typeList.selectedVal,true);
  end
  if self.defaultSelectedFData ~= nil then
    self.typeList:setSelected(2,true);
    self:onSendNewData(self.defaultSelectedFData);
    self.defaultSelectedFData = nil;
  end
end

function Lua_FriendPanel:onFaceClick(go)
	local p = {};
	p.offsetX = 134;
	p.offsetY = -98;
  p.owner = self;
  p.callBack = self.onFaceSelected;
	Lua_WindowUtil.openWin("Lua_ChatFaceWindow", nil, p);
end

function Lua_FriendPanel:onAddClick()
  Lua_WindowUtil.openWin("Lua_AddFriendWindow");
end

function Lua_FriendPanel:onHuaClick()
  --Lua_WindowUtil.openWin("Lua_MailBoxWindow",WinParam.ACTION_CLOSE,nil);
  Lua_WindowUtil.openWin("Lua_FriendSendFlowerWindow");
end

function Lua_FriendPanel:onFaceSelected(val)
  if self.msgText.text == self.defaultMsg then
    self.msgText.text = "/"..val;
  else
    self.msgText.text = self.msgText.text.."/"..val;
  end
end

function Lua_FriendPanel:onSendNewData(data)
  local findInList = false;
  local arr = self.typeList.dragList.showList;
  for i = 1, arr:getSize() do
    if arr[i]._data.name==data.data.name and arr[i]._data.type==data.type then
      arr[i]:setSelected(true);
      findInList = true;
    else
      arr[i]:setSelected(false);
    end
    if arr[i]._data.name==data.data.name then
      arr[i]:setRedDot(false);
    end
  end

  for i=1,self.arr:getSize() do
    for j=1 ,self.arr[i].sub:getSize() do
      if self.arr[i].sub[j].name==data.data.name then
        self.arr[i].sub[j].isShow=false;
      end
    end
  end
  self.typeList:setRedDotData(self.arr);
  self.selectedData = data;
  if findInList == true and data ~= nil then
    self.talkTxt.text = LanUtil.formateStr(LanUtil.getValue(120214),data.name);
    self:onUpdateChatMsg(tonumber(self.selectedData.data.role_id));
  else
    self.talkTxt.text = LanUtil.getValue(120213);
  end
  self:setTypeListRedDot();
end

function Lua_FriendPanel:updateFriendRequestTips(obj)
  if tonumber(obj.evenId) == 10008 then
    if tonumber(obj.val) > 0 then
      self.redSp.uiwidget.gameObject:SetActive(true);
    else
      self.redSp.uiwidget.gameObject:SetActive(false);
    end
  end
end

function Lua_FriendPanel:updateGroudRedDot()
  self:setItemData();
  self:setTypeListRedDot();
  if self.typeList.selectedVal~=nil and self.arr[self.typeList.selectedVal] ~= nil and self.arr[self.typeList.selectedVal].sub~=nil then
    self.typeList:setSelected(self.typeList.selectedVal,true);
  end
end

function Lua_FriendPanel:setItemData()
	self.arr = Array();
  local all_list = DataCenter.friendData:getAllTypeList()
  for k,v in pairs(all_list) do
    self.sub = Array();
    self.onLineNum=0;
    for j=1,v:getSize() do
      if v[j].info.is_online==1 then
        self.onLineNum=self.onLineNum+1;
      end
      local chatRedDotList = DataCenter.chatData.redDotList;
      local enemyRedDotList = DataCenter.friendData.enemyRedDotList;
      local itemRedDot=false;
      if k==1 or k==2 then
        if chatRedDotList[tonumber(v[j].info.role_id)]~=nil and chatRedDotList[tonumber(v[j].info.role_id)]==true then
          itemRedDot = true;
        end
      elseif k==3 then
        if enemyRedDotList[tonumber(v[j].info.role_id)]~=nil and enemyRedDotList[tonumber(v[j].info.role_id)]==true then
          itemRedDot = true;
        end
      end
      self.sub:add({name=v[j].info.name,selected=false, data=v[j].info,type=k,isShow=itemRedDot});
    end
    self.arr:add({name=self.nameList[k],text=self.onLineNum.."/"..v:getSize(), sub=self.sub});
  end
  self.typeList:setData(self.arr,false);
  self.typeList.dragList:setSubPos(0, 11);
end

function Lua_FriendPanel:setTypeListRedDot()
  local all_list = DataCenter.friendData:getAllTypeList()
  local chatRedDotList = DataCenter.chatData.redDotList;
  local enemyRedDotList = DataCenter.friendData.enemyRedDotList;
  for k,v in pairs(all_list) do
    local isShow=false;
    for j=1,v:getSize() do
       if k==1 or k==2 then
        if chatRedDotList[tonumber(v[j].info.role_id)]~=nil and chatRedDotList[tonumber(v[j].info.role_id)]==true then
          isShow = true;
        end
      elseif k==3 then
        if enemyRedDotList[tonumber(v[j].info.role_id)]~=nil and enemyRedDotList[tonumber(v[j].info.role_id)]==true then
          isShow = true;
        end
      end
    end
    self.typeList:setRedDotStateByIndex(k,isShow);
  end
  self.typeList:setRedDotPos(163,20);
end

function Lua_FriendPanel:onShenQingClick()
  Lua_WindowUtil.openWin("Lua_FriendRequestWindow",WinParam.ACTION_OPEN,nil);
end

function Lua_FriendPanel:onSoundClick(go)
  if self.selectedData == nil then
    OperateAlert.show(LanUtil.getValue(120215));
    return;
  end
  local showPos = Vector3(100, 0,0);
  Lua_WindowUtil.openWin("Lua_ChatSoundWindow", WinParam.ACTION_OPEN,showPos);
  ChatRecordSound.getInstance():startRecord();
end

function Lua_FriendPanel:onSoundUpClick(go)
  Lua_WindowUtil.openWin("Lua_ChatSoundWindow", WinParam.ACTION_CLOSE);
  local v = Vector3(UnityEngine.Input.mousePosition.x,UnityEngine.Input.mousePosition.y,0);
  local screenpos = UICamera.mainCamera:ScreenToWorldPoint(v);
  local mousePosition = self.soundBtn.mainContent.transform:InverseTransformPoint(screenpos);
  
  if mousePosition.x > 0 and mousePosition.x < 50 and mousePosition.y > - 25 and mousePosition.y < 25 then
    self.isCancel = false;
  else
    self.isCancel = true;
  end
  ChatRecordSound.getInstance():stopRecord();
end

function Lua_FriendPanel:onVoiceDown(o)
  if self.isCancel == false then
    if CommonUtil.isApplePlatform == false then
      ChatUtil.sendVoiceMsg(Lua_CommonUtil.trnsLongNum(self.selectedData.data.role_id));
    else
      Lua_ChatUtil.sendPrivateVoiceMsg(tonumber(self.selectedData.data.role_id));
    end
  end
  ChatRecordSound.getInstance():clear();
end