Lua_FriendRequestWindow = class("Lua_FriendRequestWindow", Lua_Window);
function Lua_FriendRequestWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_FriendRequestWindow";
	self.skinName = "FriendRequestWindow_skin";
end
function Lua_FriendRequestWindow:buildShowItem()
	self:superCall("buildShowItem");
    self.agreeBtn:addClickFuntion(self,self.onAgreeClick);
    self.refusedBtn:addClickFuntion(self,self.onRefuseClick);
    --self:addLuaEvent("UPDATE_FRIEND_REQUEST",self,self.updateFriendRequest);--有好友申请过来，刷新界面
    self:addLuaEvent("UPDATE_FRIEND_REQUEST_TIPS",self,self.updateFriendRequestTips);--刷新好友添加tips显示
    self.requestDragList = Lua_DragList.new(self.content,1, Vector4(-48, -201, 884, 353));
	self.requestDragList:setLocation(48, 192, 0);
	self.requestDragList:setListCell(FriendRequestItem, 55, 880, 1);
    --self.tarr = Lua_WindowUtil.getWinData(self.windowName,true);
    --self.requestDragList:setLuaArrayData(self.tarr, false);
    sendMsg(10100167);
end

-- function Lua_FriendRequestWindow:updateFriendRequest()
--    local RequestList = DataCenter.friendData:getFriendRequestList()
--    if RequestList:getSize()>0 then
--       self.requestDragList:setLuaArrayData(RequestList, false);
--    end
-- end
FriendRequestItem = class("FriendRequestItem", Lua_ListCell);
function FriendRequestItem:ctor(p)
	self:superCall("ctor", p, "FriendRequestItem_skin");
end
function FriendRequestItem:buildShowItem()
	self:superCall("buildShowItem");
    self.addBtn:addClickFuntion(self,self.onAddBtnClick);
    self.refusedBtn:addClickFuntion(self,self.onRefusedBtnClick);
end
function FriendRequestItem:setData(data)
   self._data=data;
   self.nameTxt.text=data.friend_name;
   self.lvTxt.text=string.sub(LanUtil.formateStr(LanUtil.getValue(120111), tostring(data.level)),4)
end
function FriendRequestItem:onAddBtnClick()--单个同意
   local RequestList =Array();
   RequestList:add(self._data)
   DataCenter.friendData:sAgreeFriendRequest(RequestList)
   DataCenter.friendData:removeOneFriendRequest(self._data);
   --抛事件刷新界面
   Lua_MsgUtil.callFunc("UPDATE_FRIEND_REQUEST_TIPS");
end
function FriendRequestItem:onRefusedBtnClick()--单个拒绝
   local RequestList =Array();
   RequestList:add(self._data)
   DataCenter.friendData:sRefusedFriendRequest(RequestList)
   DataCenter.friendData:removeOneFriendRequest(self._data);
   --抛事件刷新界面
   Lua_MsgUtil.callFunc("UPDATE_FRIEND_REQUEST_TIPS");
end
function Lua_FriendRequestWindow:onAgreeClick()--全部同意
   local RequestList = DataCenter.friendData:getFriendRequestList()
   DataCenter.friendData:sAgreeFriendRequest(RequestList)
   DataCenter.friendData:clearFriendRequestList()
   --抛事件刷新界面
   Lua_MsgUtil.callFunc("UPDATE_FRIEND_REQUEST_TIPS");
   self:hide();
end
function Lua_FriendRequestWindow:onRefuseClick()--全部拒绝
   local RequestList = DataCenter.friendData:getFriendRequestList()
   DataCenter.friendData:sRefusedFriendRequest(RequestList)
   DataCenter.friendData:clearFriendRequestList()
   --抛事件刷新界面
   Lua_MsgUtil.callFunc("UPDATE_FRIEND_REQUEST_TIPS");
   self:hide();
end
function Lua_FriendRequestWindow:updateFriendRequestTips()
   local RequestList = DataCenter.friendData:getFriendRequestList()
   self.requestDragList:setLuaArrayData(RequestList, false);
end