Lua_FriendSendFlowerWindow = class("Lua_FriendSendFlowerWindow", Lua_Window);
function Lua_FriendSendFlowerWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_FriendSendFlowerWindow";
    self.skinName = "FriendSendFlowerWindow_skin";
    self.showClose = false;
    self.isClickClose = true;
end

function Lua_FriendSendFlowerWindow:buildShowItem()
    self:superCall("buildShowItem");
    Lua_WindowUtil.openWin("Lua_MailBoxWindow",WinParam.ACTION_CLOSE, nil);
    self.nameInput.text = LanUtil.getValue(120207);
    self:addLuaEvent("SET_FRIEND_FLOWER_WINDOW", self, self.setFriendSendFlowerWindow);
    self.sendBtn.txt.effectColorStr = Lua_ColorDefine.transColor("B52915");
    self.sendBtn.txt.color = Color.New(1, 1, 1, 1);
    self.nameListBg:addClickFuntion(self, self.onNameBgClick);
    self.closeBtn:addClickFuntion(self, self.onHideBtnClick);
    self.flowerListBg:addClickFuntion(self, self.onFlowerBgClick);
    self.sendBtn:addClickFuntion(self, self.onSendBtnClick);
    self.ruleSp:addClickFuntion(self, self.onRuleSpClick);
    self.nameCheckBox:addBoxChange(self, self.onNameBoxClick)
    self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
    self.itemImg:setLocation(-240, 88, 0);
    local config = DataCenter.friendData:getMarriageConfig();
    self.flowerConfigList = Array();
    for i = 1,config:getSize() do
        local info={}
        local itemConfig = Lua_WingUtil.getItemData(config[i].item_id)
        info.item_id = config[i].item_id
        info.flower_name = itemConfig.name
        info.need_gold = itemConfig.goldPrice
        info.add_intimacy = config[i].intimacy
        self.flowerConfigList:add(info);
    end
    self:setFlowerType(1);
    self.is_anonymity=0;
    local windowData = Lua_WindowUtil.getWinData(self.windowName, true);
	if(windowData ~= nil and windowData.name ~= nil) then
        self:setSendPlayer(windowData);
    else
        DataCenter.friendData:sOnlineFriend();
	end
end

function Lua_FriendSendFlowerWindow:setSendPlayer(data)
    self.nameListBg.uiwidget.gameObject:SetActive(false);
    self.nameInput.text = data.name;
    self.desLabel2.text = LanUtil.formateStr(LanUtil.getValue(120114), string.format("[ffe3a4]%s[-]", data.name),
    tostring(self.flowerConfigList[self.flowerType].add_intimacy));

end

function Lua_FriendSendFlowerWindow:onRuleSpClick(go)
   Lua_WindowUtil.openWin("Lua_FriendSendFlowerRuleWindow");
end

function Lua_FriendSendFlowerWindow:setFriendSendFlowerWindow()
    self.friendList = DataCenter.friendData:getOnlineFriendList();
    if self.friendList:getSize() > 0  then
       self:setNameType(1);
    end
end

function Lua_FriendSendFlowerWindow:onNameBgClick(go)
	local dragData = {};
	dragData.datas = Array();
    for i=1,self.friendList:getSize() do
       dragData.datas:add("[ffffff]" .. self.friendList[i].info.name .. "[-]");
    end
	dragData.offsetX = 77;
	dragData.offsetY = -7;
    dragData.width = 231;
    dragData.height = 210; 
    dragData.rowSpacing = 38;
	dragData.callBackOwner = self;
	dragData.callBack = self.onNameDragDownCallBack;
    dragData.selected = self.nameType;
    dragData.flowerWin = self.windowName;
    dragData.bgAltas = "common_atlas_1";
    dragData.bgSprite = "ui_common_widget_srk";
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_FriendSendFlowerWindow:onNameDragDownCallBack(val)
	self:setNameType(val);
end

function Lua_FriendSendFlowerWindow:setNameType(val)
    self.nameType = val
    self.nameInput.text = self.friendList[val].info.name;
    if self.friendList[val].info.name== DataCenter.roleData.name then
        self:onNameBoxClick(true)
        self.nameCheckBox.seleted = true
        self.desLabel2.uiwidget.gameObject:SetActive(false);
    else
        self:onNameBoxClick(false)
        self.nameCheckBox.seleted = false
        self.desLabel2.uiwidget.gameObject:SetActive(true);
    end
    self:setDesLabel2();
end
function Lua_FriendSendFlowerWindow:onFlowerBgClick(go)
	local dragData = {};
	dragData.datas = Array();
	dragData.datas:add(LanUtil.getValue(120115));
	dragData.datas:add(LanUtil.getValue(120116));
	dragData.datas:add(LanUtil.getValue(120117));
	dragData.datas:add(LanUtil.getValue(120118));
	dragData.offsetX = 77;
	dragData.offsetY = -73;
    dragData.width = 231;
    dragData.height = 210;
    dragData.rowSpacing = 38;
	dragData.callBackOwner = self;
	dragData.callBack = self.onFlowerDragDownCallBack;
    dragData.selected = self.flowerType;
    dragData.flowerWin = self.windowName;
    dragData.bgAltas = "common_atlas_1";
    dragData.bgSprite = "ui_common_widget_srk";
	Lua_WindowUtil.openWin("Lua_DragDownWindow", nil, dragData);
end

function Lua_FriendSendFlowerWindow:onFlowerDragDownCallBack(val)
	self:setFlowerType(val);
end

function Lua_FriendSendFlowerWindow:setFlowerType(val)
    self.flowerType=val
    self.flowerTxt2.text=self.flowerConfigList[val].flower_name;
    self.flowerTxt.text=self.flowerConfigList[val].flower_name;
    self.itemImg.data =Lua_ToolVo.new(self.flowerConfigList[val].item_id);   
    self:setDesLabel2();
end

function Lua_FriendSendFlowerWindow:setDesLabel2()
  if self.flowerType ~= nil and self.nameType ~= nil then
     self.nameLabel.text = self.friendList[self.nameType].info.name;
     self.desLabel2.text = LanUtil.formateStr(LanUtil.getValue(120114),string.format("[ffe3a4]%s[-]",""),
     tostring(self.flowerConfigList[self.flowerType].add_intimacy));
     local posXOffest = self.nameLabel.width - 52;
     self.nameLabel:setLocation(-63 + posXOffest / 2, -97, 0);
     self.desLabel2:setLocation(-60 + posXOffest / 2, -97, 0);
  elseif self.flowerType ~= nil and self.nameType == nil then
     self.nameLabel.text = LanUtil.getValue(120124);
     self.desLabel2.text = LanUtil.formateStr(LanUtil.getValue(120114),string.format("[ffe3a4]%s[-]",""),
     tostring("    "..self.flowerConfigList[self.flowerType].add_intimacy));
     self.nameLabel:setLocation(-95, -97, 0);
     self.desLabel2:setLocation(-90, -97, 0);
  end
end

function Lua_FriendSendFlowerWindow:onSendBtnClick()
    self.had_Count = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(self.flowerConfigList[self.flowerType].item_id);
    if self.had_Count > 0 then
        self.is_buy = 0;
        self:sSendFlower();
    else
        self.is_buy = 1;
        local price = self.flowerConfigList[self.flowerType].need_gold; --魅力之王活动特殊处理
        if DataCenter.charmKingData.isOpen == true and self.flowerConfigList[self.flowerType].item_id == DataCenter.charmKingData.discount_item_id then
            price = DataCenter.charmKingData.discount_price;
        end
        local tipData = { };
        tipData.des = LanUtil.formateStr(LanUtil.getValue(120122), string.format("[ff0000]%s[-]", self.flowerConfigList[self.flowerType].flower_name), tostring(price));
        tipData.owner = self;
        tipData.type = 1;
        tipData.subFun = self.sSendFlower;-- 确定
        Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
    end
end

function Lua_FriendSendFlowerWindow:onNameBoxClick(state)
   if state==true then
      self.is_anonymity = 1
   else
      self.is_anonymity = 0
   end
end

function Lua_FriendSendFlowerWindow:sSendFlower()
    if tostring(self.nameInput.text) == DataCenter.roleData.name  then
        OperateAlert.show(LanUtil.getValue(141218));
    else
        local cmd = ProtoPublic_pb.Proto10101406();
        cmd.item_id = self.flowerConfigList[self.flowerType].item_id;
        cmd.recv_name = tostring(self.nameInput.text);
        cmd.is_anonymity = self.is_anonymity;
        cmd.is_buy = self.is_buy;
        sendMsg(10101406,cmd);
    end
end

function Lua_FriendSendFlowerWindow:onHideBtnClick()
    self:hide();
    Lua_WindowUtil.openWin("Lua_DragDownWindow", WinParam.ACTION_CLOSE, nil);
    Lua_WindowUtil.openWin("Lua_FriendSendFlowerRuleWindow", WinParam.ACTION_CLOSE, nil);
    Lua_MsgUtil.callFunc("UPDATE_RETRUN_FLOWER_WINDOW");
end