Lua_LoveGiftWindow = class("Lua_LoveGiftWindow", Lua_Window);
function Lua_LoveGiftWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_LoveGiftWindow";
	self.skinName = "LoveGiftWindow_skin";
end

function Lua_LoveGiftWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.desLab.text = LanUtil.getValue(124142);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setLayout(100, 80, 5);
	self.rItem:setMaxShow(5);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	-- self.rItem:setItemScale(0.9, 0.9);
	self.rItem:setLocation(-80, 30, 0);
	self.rItem:setRewardByRewardList(Array(12402));

	local marryData = DataCenter.marryData;
	local modelData = UsData();
	modelData.roleId = marryData.Married_partner_id; -- 任务id
	modelData.nickname = marryData.Married_partner_name; -- 
	modelData.gender = marryData.Married_partner_sex; -- 性别
	modelData.weapon_id = marryData.weapon; -- 武器
	modelData.clothes_id = marryData.fashion; -- 衣服
	modelData.fashion_weapon_id = marryData.fashion_weapon_id; -- 
	modelData.fashion_clothes_id = marryData.fashion_clothes_id; -- 
	modelData.fashionHeadId = marryData.fashion_headgear_id; -- 
	-- modelData.lvl = self.data.level; -- 等级
	modelData.career = marryData.partner_career; -- 职业
	modelData.wingId = marryData.wing_id; -- 仙羽等级
	modelData.profession = marryData.partner_profession; -- 当前转职次数
	modelData.showShadow = false;
	modelData.canBeClick = false;
	modelData.isShowName = false;
	modelData.IsUI = true;
	modelData.hp = 1;
	modelData.kind = 1;

	self.playerModel = ModelPlayer();
	self.playerModel:init(self.content, Vector3(281, -90, -100), Vector3(0, 90, 0), modelData, nil, 125);
	self.playerModel:SetRenderQueue(self.herNameTxt, -1, 2);
	self.playerModel:setGray(false);
	self.playerModel:setActive(true);

	-- 立得红点
	self.lRedDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", -234, -73, 0, 0);
	self.lRedDot.name = "lRedDot";
	self.lRedDot:setDepth(10);
	self.lRedDot:setEnable(false);

	-- 每日红点
	self.eRedDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 42, -73, 0, 0);
	self.eRedDot.name = "eRedDot";
	self.eRedDot:setDepth(10);
	self.eRedDot:setEnable(false);

	self.askTxt:addClickFuntion(self, self.onAskClick);
	self.ruleIcon:addClickFuntion(self, self.onRuleSpClick);

	self:setPanelData();
	self:addLuaEvent("SET_LOVE_GIFT_PANEL", self, self.setPanelData);
end

function Lua_LoveGiftWindow:setPanelData()
	self.myInfoData = DataCenter.marryData.self_treasure;
	self.myBuyTick = tonumber(tostring(self.myInfoData.buy_tick));
	if self.myBuyTick ~= 0 then
		local time = tonumber(self.myInfoData.left_time) - tonumber(tostring(GlobalVar.cur_tick))
		local myTimeStr =  TimeTransform.getInstance():transTimeLeft(time);
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124140), tostring(myTimeStr));
	else
		self.timeTxt.text = LanUtil.getValue(124167);
	end

	self.herInfoData = DataCenter.marryData.side_treasure;
	if tonumber(tostring(self.herInfoData.buy_tick)) ~= 0 then
		local time = tonumber(self.herInfoData.left_time) - tonumber(tostring(GlobalVar.cur_tick))
		local herTimeStr =  TimeTransform.getInstance():transTimeLeft(time);
		self.herTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(124141), tostring(herTimeStr));
	else
		self.herTimeTxt.text = LanUtil.getValue(124168)
	end

	if (self.myBuyTick ~= 0 and self.myInfoData.once_reward == 1) or self.myBuyTick == 0 then
		self.leftBuyBtn.txt.colorStr = Lua_ColorDefine.transColor("A5A4A4");
		self.leftBuyBtn:setStyle(33);
		self.leftBuyBtn:removeClickFuntion(self, self.onLeftBuyClick);
		if self.myBuyTick == 0 then
			self.askObj:SetActive(true);
			self.desLab:setLocation(-416, -206, 0);
			self.leftBuyBtn.label = LanUtil.getValue(122527);
		else
			self.askObj:SetActive(false);
			self.leftBuyBtn.label = LanUtil.getValue(122528);
		end
		self.lRedDot:setEnable(false);
	else
		self.leftBuyBtn.label = LanUtil.getValue(122527);
		self.leftBuyBtn.txt.colorStr = Lua_ColorDefine.transColor("FFFCB7");
		self.leftBuyBtn:setStyle(16);
		self.leftBuyBtn:addClickFuntion(self, self.onLeftBuyClick);

		self.desLab:setLocation(-416, -188, 0);
		self.askObj:SetActive(false);
		self.lRedDot:setEnable(true);
	end

	if self.myBuyTick == 0 or self.myInfoData.day_reward == 1 then
		self.rightBuyBtn.txt.colorStr = Lua_ColorDefine.transColor("A5A4A4");
		self.rightBuyBtn:setStyle(33);
		self.rightBuyBtn:removeClickFuntion(self, self.onRightGetClick);
		if self.myInfoData.day_reward == 1 then
			self.rightBuyBtn.label = LanUtil.getValue(122528);
		end
		self.eRedDot:setEnable(false);
	else
		self.rightBuyBtn.label = LanUtil.getValue(122527);
		self.rightBuyBtn.txt.colorStr = Lua_ColorDefine.transColor("FFFCB7");
		self.rightBuyBtn:setStyle(16);
		self.rightBuyBtn:addClickFuntion(self, self.onRightGetClick);
		self.eRedDot:setEnable(true);
	end

	if tonumber(tostring(self.herInfoData.buy_tick)) ~= 0 then
		self.buyBtn:setStyle(21);
		self.buyBtn:removeClickFuntion(self, self.onHerLoveClick);
	else
		self.buyBtn:setStyle(20);
		self.buyBtn:addClickFuntion(self, self.onHerLoveClick);
	end
	self.herNameTxt.text = DataCenter.marryData.Married_partner_name;
end

function Lua_LoveGiftWindow:onRuleSpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(124169));
end

function Lua_LoveGiftWindow:onLeftBuyClick()
	local cmd = ProtoPublic_pb.Proto10101414();
	cmd.type = 1;
	sendMsg(10101414, cmd);
end

function Lua_LoveGiftWindow:onRightGetClick()
	local cmd = ProtoPublic_pb.Proto10101414();
	cmd.type = 2;
	sendMsg(10101414, cmd);
end

function Lua_LoveGiftWindow:onAskClick()
	local cmd = ProtoPublic_pb.Proto10101413();
	cmd.type = 2;
	sendMsg(10101413, cmd);
end

function Lua_LoveGiftWindow:onHerLoveClick()
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, type = 1, subFun = self.onAgree,
		des = LanUtil.formateStr(LanUtil.getValue(124138), tostring(DataCenter.marryData.loveGiftGold))});
end

function Lua_LoveGiftWindow:onAgree()
	-- 检查元宝是否足够
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD, DataCenter.marryData.loveGiftGold, false, true) == false then 
		-- self:hide();
		return;
	end

	local cmd = ProtoPublic_pb.Proto10101413();
	cmd.type = 1;
	sendMsg(10101413, cmd);
end

function Lua_LoveGiftWindow:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.playerModel ~= nil then
		self.playerModel:dispose();
		self.playerModel = nil;
	end

	self:superCall("dispose");
end