checkRequire("Lua_MarryUtil");
checkRequire("Lua_LoveGiftParamItem");
Lua_MarriedPanel = class("Lua_MarriedPanel", Lua_DisplayObject);
function Lua_MarriedPanel:ctor(p)
	self:superCall("ctor", p, "MarriedPanel_skin");

	self.isClick = false;
	self.selectId = 0;
	self.itemId = 0;
end

function Lua_MarriedPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.acopyDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11310)); -- 副本红点
	self.lRedDot:setEnable(false); -- 礼盒红点
	self.aRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11601)); -- 一键提升红点
	self.uRedDot:setEnable(DataCenter.redDotData:getRedDotStateByEventId(11601)); -- 提升红点

	-- 改为检测是否一键提升，是就取消否则按原有逻辑
	-- self.mask = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 2000, 2000);
	-- self.mask.alpha = 0.5;
	-- self.mask:setDepth(10);
	-- self.mask:addClickFuntion(self, self.onMaskClick);
	-- self.mask:setEnable(false);

	self.propImg = Lua_ToolImage.new(self.content);
	self.propImg:setDepth(5);
	self.propImg:setScale(0.9, 0.9);
	self.propImg:setLocation(145, 188, 0);

	self.paramArr1 = Array();
	self.paramArr2 = Array();
	self.costItemArr = Array();

	self.titleSp:addLoadCompleteFun(self, self.onLoadCompleteImg);
	self.icon1:addClickFuntion(self, self.onWeddingCopyClick);
	self.icon2:addClickFuntion(self, self.onLoveGiftClick);
	self.icon3:addClickFuntion(self, self.onMakeWeddingClick);
	self.autoUpBtn:addClickFuntion(self, self.onAutoUpClick);
	self.oneUpBtn:addClickFuntion(self, self.onOnceUpClick);
	self.leftArrow:addClickFuntion(self, self.onLeftChange);
	self.rightArrow:addClickFuntion(self, self.onRightChange);

	self:addLuaEvent("SET_MARRY_PANEL", self, self.setPanelData);
	self:addLuaEvent("RING_UPDATE", self, self.setChargeThings);
	self:addLuaEvent("REMOVE_AUTO_UP", self, self.removeAutoUp);
	self:addLuaEvent("SET_LOVE_GIFT_PANEL", self, self.setLoveGiftRedDot);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateUpBtnRedDot);

	local cmd = ProtoPublic_pb.Proto10101407();
	cmd.open_panel = 1;
	sendMsg(10101407, cmd);
	self:setLoveGiftRedDot();
end

function Lua_MarriedPanel:setLoveGiftRedDot()
	self.treasure = DataCenter.marryData.self_treasure;
	if tonumber(tostring(self.treasure.buy_tick)) ~= 0 then
		self.lRedDot:setEnable(self.treasure.day_reward == 0 or self.treasure.once_reward == 0);
	end
end

function Lua_MarriedPanel:setPanelData()
	local keepsakeInfo = DataCenter.marryData.keepsake_info;
	if isHeadReplaceOpen() == true then
		self:updateHerHead(DataCenter.marryData.partner_career, DataCenter.marryData.role_head_name);
		self:updateMyHead(DataCenter.roleData.career, DataCenter.roleData.getDressHead);
	else
		self.herHeadImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(DataCenter.marryData.partner_career, DataCenter.marryData.partner_profession));
		self.myHeadImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(DataCenter.roleData.career, DataCenter.roleData.profession));
	end

	local timeStr = TimeTransform.getInstance():transSeconds8(DataCenter.marryData.wedding_tick, "yyyy-MM-dd") .. "  ";
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(124137), tostring(timeStr));
	-- self.intimacyTxt2.text=LanUtil.formateStr(LanUtil.getValue(124135), tostring(DataCenter.marryData.intimacy));
	self.intimacyTxt1.text = DataCenter.marryData.Married_intimacy;
	self.intimacyTxt3.text = DataCenter.marryData.Married_intimacy;
	self.conditionTxt.text = LanUtil.formateStr(LanUtil.getValue(124136), tostring(DataCenter.marryData.Married_intimacy));
	self.propImg.data = Lua_ToolVo.new(keepsakeInfo.keepsake_id);
	self.toolName.text = self.propImg.data.name;
	self.titleConfig = Lua_MarryUtil.getMarryTitle();
	
	if DataCenter.marryData.label_id == 0 then
		DataCenter.marryData.label_id = 1000057;
	end

	self.titleSp:setAltas("item7", tostring(DataCenter.marryData.label_id));
	if DataCenter.marryData.label_id == self.titleConfig[#self.titleConfig].label_id then
		self.leftArrow:setAltas("common_atlas_2", "ui_common_jiantou_01");
		self.rightArrow:setAltas("common_atlas_2", "ui_common_jiantou_02");
	elseif DataCenter.marryData.label_id == self.titleConfig[1].label_id then
		self.leftArrow:setAltas("common_atlas_2", "ui_common_jiantou_02");
		self.rightArrow:setAltas("common_atlas_2", "ui_common_jiantou_01");
	else
		self.leftArrow:setAltas("common_atlas_2", "ui_common_jiantou_01");
		self.rightArrow:setAltas("common_atlas_2", "ui_common_jiantou_01");
	end

	for i, v in ipairs(self.titleConfig) do
		if v.label_id == DataCenter.marryData.label_id then
			self.conditionTxt.text = LanUtil.formateStr(LanUtil.getValue(124136), tostring(v.need_intimacy));
		end
	end

	local id = (keepsakeInfo.keepsake_id % 10) * 1000 + keepsakeInfo.keepsake_lvl;
	local config = Lua_MarryUtil.getMarryPledge(id + 1);
	if config == nil then
		config = Lua_MarryUtil.getMarryPledge(id);
	end

	local item;
	for i = 1, #config.cost_item do
		item = self.costItemArr[i];
		if item == nil then
			item = Lua_ToolImage.new(self.content);
			item:setDepth(5);
			item:setLocation(145 + (i - 1) * 100, -218, 0);
			self.costItemArr:add(item);
		end
		item.data = Lua_ToolVo.new(config.cost_item[i][1]);
	end
	self:setChargeThings()
end

function Lua_MarriedPanel:updateHerHead(career, role_head)
	if role_head ~= nil and role_head ~= "" then
		local isDefault = DataCenter.roleData:isDefaultHead(career, role_head);
		if isDefault == true then
			self.herHeadImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
			self.herHeadImg:SetDimensions(104, 94);
		else
			self.herHeadImg:setUrl(role_head, 99, true);
			self.herHeadImg:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
			self.herHeadImg:SetDimensions(79, 79);
		end
	end
end

function Lua_MarriedPanel:updateMyHead(career, role_head)
	if role_head ~= nil and role_head ~= "" then
		local isDefault = DataCenter.roleData:isDefaultHead(career, role_head);
		if isDefault == true then
			self.myHeadImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
			self.myHeadImg:SetDimensions(104, 94);
		else
			self.myHeadImg:setUrl(role_head, 99, true);
			self.myHeadImg:setRoundSize(0, 0.5, 0.5, 0.25);--圆形
			self.myHeadImg:SetDimensions(79, 79);
		end
	end
end

function Lua_MarriedPanel:setChargeThings()
	self.keepsakeInfo = DataCenter.marryData.keepsake_info;
	local id = (self.keepsakeInfo.keepsake_id % 10) * 1000 + self.keepsakeInfo.keepsake_lvl;
	local config = Lua_MarryUtil.getMarryPledge(id + 1)
	if config == nil then
		config = Lua_MarryUtil.getMarryPledge(id)
	end

	self.isMax = self.keepsakeInfo.keepsake_lvl == config.max_level;
	if self.isMax == false then
		for i = 1, #config.cost_item do
			local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(config.cost_item[i][1]);
			local needNum = config.cost_item[i][2];
			self.costItemArr[i]:showNumLimit(itemNum, needNum, 2);
		end
		-- self.currentObj.transform.localPosition = Vector3(-48, 56, 0);
		LuaUtil.setObjPos(self.currentObj, -48, 56, 0);

		self.expBar:setPercent(self.keepsakeInfo.keepsake_exp / config.need_exp);
		self.expBar.txt.text = self.keepsakeInfo.keepsake_exp .. "/" .. config.need_exp;
	else
		-- self.currentObj.transform.localPosition = Vector3(145, 56, 0);
		LuaUtil.setObjPos(elf.currentObj, 145, 56, 0);

		self.expBar:setPercent(1);
		self.expBar.txt.text = (config.need_exp .. "/" .. config.need_exp);
	end
	self.nextObj:SetActive(not self.isMax);
	self.autoUpBtn:setEnable(not self.isMax);
	self.oneUpBtn:setEnable(not self.isMax);
	self.needTxt:setEnable(not self.isMax);
	self.maxLvlTxt:setEnable(self.isMax);
	self.expBar.txt:setEnable(true);
	for i = 1, self.costItemArr:getSize() do
		self.costItemArr[i]:setEnable(not self.isMax);
	end

	local stage = math.floor(self.keepsakeInfo.keepsake_lvl / 10) + 1;
	local starLvl = self.keepsakeInfo.keepsake_lvl % 10;
	self.lvlTxt.text = LanUtil.formateStr(LanUtil.getValue(124132), tostring(stage), tostring(starLvl)) .. "：";

	-- 爱情信物属性
	local index = 1;
	local itemIndex = 1;
	for i, v in ipairs(Lua_ThingDefine.params) do
		local param = Lua_MarryUtil.getAttConfig(id, v);
		if param ~= nil and param ~= 0 then
			if self.isMax == false then
				if self.paramArr1[itemIndex] == nil then
					local paramItem1 = Lua_LoveGiftParamItem.new(self.content);
					self.paramArr1:add(paramItem1);
				end

				if self.paramArr2[itemIndex] == nil then
					local paramItem2 = Lua_LoveGiftParamItem.new(self.content);
					self.paramArr2:add(paramItem2);
					itemIndex = itemIndex + 1
				end
				self.paramArr1[index]:setData(v, param);
				self.paramArr1[index]:setLocation(-138, 18 - (index - 1) * 26);

				local param2 = Lua_MarryUtil.getAttConfig(id + 1, v);
				self.paramArr2[index]:setData(v, param2, false, true);
				self.paramArr2[index]:setLocation(264, 18 -(index - 1) * 26);
			else
				if self.paramArr1[itemIndex] == nil then
					local paramItem = Lua_LoveGiftParamItem.new(self.content);
					self.paramArr1:add(paramItem);
					itemIndex = itemIndex + 1
				end
				self.paramArr1[index]:setData(v, param);
				self.paramArr1[index]:setLocation(-42, 18 -(index - 1) * 28);
			end
			index = index + 1;
		end
	end
end

function Lua_MarriedPanel:removeAutoUp()
	Lua_CommonUtil.removeTimer(self, self.onOnceUpClick);
	self.autoUpBtn.label = LanUtil.getValue(124133);
	self.isClick = false;
	-- self.mask:setEnable(false);
end

function Lua_MarriedPanel:updateUpBtnRedDot(obj)
	if tonumber(obj.evenId) == 11601 then
		self.aRedDot:setEnable(tonumber(obj.val) > 0);
		self.uRedDot:setEnable(tonumber(obj.val) > 0);
	end

	if tonumber(obj.evenId) == 11310 then
		self.acopyDot:setEnable(tonumber(obj.val) > 0);
	end
end

function Lua_MarriedPanel:onMaskClick(go)
end

function Lua_MarriedPanel:onLoadCompleteImg()
	self.titleSp:resetSize();
end

function Lua_MarriedPanel:onWeddingCopyClick()
	if self.isClick == true then
		self:onAutoUpClick();
	end
	Lua_WindowUtil.openWin("Lua_CopyYinYuanWindow", nil, Lua_CopyData.YINYUAN_COPY);
end

function Lua_MarriedPanel:onLoveGiftClick()
	if self.isClick == true then
		self:onAutoUpClick();
	end
	Lua_WindowUtil.openWin("Lua_LoveGiftWindow", WinParam.ACTION_OPEN);
end

function Lua_MarriedPanel:onMakeWeddingClick()
	if self.isClick == true then
		self:onAutoUpClick();
	end
	OperateAlert.show(LanUtil.getValue(110062));
	sendMsg(10101403);
	-- Lua_WindowUtil.openWin("Lua_WeddingBanquetWindow", WinParam.ACTION_OPEN);
end

function Lua_MarriedPanel:onAutoUpClick()
	self.isClick = not self.isClick;
	if self.isClick then
		Lua_CommonUtil.addTimer("onOnceUpClick", 0.1, self, self.onOnceUpClick);
		self.autoUpBtn.label = LanUtil.getValue(124134);
		-- self.mask:setEnable(true);
	else
		Lua_CommonUtil.removeTimer(self, self.onOnceUpClick);
		self.autoUpBtn.label = LanUtil.getValue(124133);
		-- self.mask:setEnable(false);
	end
end

function Lua_MarriedPanel:onOnceUpClick()
	-- sendMsg(10101405);
	if self.lastLvlTime == nil then
		self.lastLvlTime = 0;
	end
	if getTime() - self.lastLvlTime > 0.05 then
		sendMsg(10101405);
		self.lastLvlTime = getTime();
	end
end

function Lua_MarriedPanel:onLeftChange()
	self.selectId = self.selectId - 1;
	self:setTitle();
end

function Lua_MarriedPanel:onRightChange()
	self.selectId = self.selectId + 1;
	self:setTitle();
end

function Lua_MarriedPanel:setTitle()
	-- self.titleData=Lua_ToolVo.new(self.itemId);
	-- self.spId = self.titleData.effect_prop.label_id+self.selectId;
	self.itemId = DataCenter.marryData.label_id + self.selectId;
	if self.itemId >= self.titleConfig[1].label_id and self.itemId <= self.titleConfig[#self.titleConfig].label_id then
		self.titleSp:setAltas("item7", tostring(self.itemId));
	end

	if self.itemId == self.titleConfig[#self.titleConfig].label_id then
		self.leftArrow:setAltas("common_atlas_2", "ui_common_jiantou_01");
		self.rightArrow:setAltas("common_atlas_2", "ui_common_jiantou_02");
	elseif self.itemId == self.titleConfig[1].label_id then
		self.leftArrow:setAltas("common_atlas_2", "ui_common_jiantou_02");
		self.rightArrow:setAltas("common_atlas_2", "ui_common_jiantou_01");
	elseif self.itemId > self.titleConfig[#self.titleConfig].label_id then
		self.selectId = self.selectId - 1;
	elseif self.itemId < self.titleConfig[1].label_id then
		self.selectId = self.selectId + 1;
	else
		self.leftArrow:setAltas("common_atlas_2", "ui_common_jiantou_01");
		self.rightArrow:setAltas("common_atlas_2", "ui_common_jiantou_01");
	end

	for i, v in ipairs(self.titleConfig) do
		if v.label_id == self.itemId then
			self.conditionTxt.text = LanUtil.formateStr(LanUtil.getValue(124136), tostring(v.need_intimacy));
		end
	end
end

function Lua_MarriedPanel:dispose()
	-- if self.mask ~= nil then
	-- 	self.mask:dispose();
	-- 	self.mask = nil;
	-- end
	if self.propImg ~= nil then
		self.propImg:dispose();
		self.propImg = nil;
	end
	if self.paramArr1 ~= nil then
		self.paramArr1:dispose();
		self.paramArr1:clear();
		self.paramArr1 = nil;
	end
	if self.paramArr2 ~= nil then
		self.paramArr2:dispose();
		self.paramArr2:clear();
		self.paramArr2 = nil;
	end
	if self.costItemArr ~= nil then
		self.costItemArr:dispose();
		self.costItemArr:clear();
		self.costItemArr = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onOnceUpClick);

	self:superCall("dispose");
end