Lua_FriendItem = class("Lua_FriendItem", Lua_ListCell);
function Lua_FriendItem:ctor(p)
	self:superCall("ctor", p, "FriendItem_skin");
end

function Lua_FriendItem:buildShowItem()
	self:superCall("buildShowItem");

    self.headIconItem = Lua_HeadIconItem.new(self.content);
    self.headIconItem:setDepth(5);
    self.headIconItem:setScale(0.7, 0.7, 0.7);
    self.headIconItem:setLocation(-117, -13, 0);
	self.headIconItem.headIcon:addClickFuntion(self,self.onHeadImgClick);
	self.heartSp:addClickFuntion(self,self.onHeartSpClick);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 163, 30, 0, 0);
	self.redDot:setDepth(6);
	self.redDot.clickScale = false;
	self.redDot.name = "redDot";
end

function Lua_FriendItem:setData(data)
	self.bselected = data.selected;
	if self.bselected == true then
		self.bg:setAltas("common_atlas_1", "ui_common_widget_p2");
		self.bgkuang:setEnable(true);
	else
		self.bg:setAltas("common_atlas_1", "ui_common_widget_p1");
		self.bgkuang:setEnable(false);
	end
	self._data = data;
	self.nameTxt.text = data.name;
	self.lvTxt.text = LanUtil.formateStr(LanUtil.getValue(120111), tostring(data.data.level));
	self.heartTxt.text = data.data.intimacy;
	self.redDot:setEnable(data.isShow);
	
	if data.data.is_online == 0 then
		self.headIconItem.headIcon.color = Color.New(0, 1, 1, 1);
	else
		self.headIconItem.headIcon.color = Color.New(1, 1, 1, 1);
	end

	if isHeadReplaceOpen() then
		if data.data.fashion_head_frame ~= nil and data.data.fashion_head_frame ~= 0 then
			self.headIconItem:setData(data.data.career, data.data.role_head_name, DataCenter.roleData:getHeadFrame(data.data.fashion_head_frame));
		else
			self.headIconItem:setData(data.data.career, data.data.role_head_name, nil);
		end
	else
		if data.data.fashion_head_frame ~= nil and data.data.fashion_head_frame ~= 0 then
			self.headIconItem:setData(data.data.career, data.data.profession, DataCenter.roleData:getHeadFrame(data.data.fashion_head_frame));
		else
			self.headIconItem:setData(data.data.career, data.data.profession, nil);
		end
	end
end

function Lua_FriendItem:setSelected(val)
	self.bselected = val;
	if self.bselected == true then
		self.bg:setAltas("common_atlas_1", "ui_common_widget_p2");
		self.bgkuang:setEnable(true);
	else
		self.bg:setAltas("common_atlas_1", "ui_common_widget_p1");
		self.bgkuang:setEnable(false);
	end
end

function Lua_FriendItem:setRedDot(val)
	self.isShow = val;
	self.redDot:setEnable(self.isShow);
end

function Lua_FriendItem:onPlayerSoundClick(go)
    local chatRedDotList = DataCenter.chatData.redDotList;
    local enemyRedDotList = DataCenter.friendData.enemyRedDotList;
	if self._data.type == 1 or self._data.type == 2 then
		if chatRedDotList[tonumber(self._data.data.role_id)] ~= nil and chatRedDotList[tonumber(self._data.data.role_id)] == true then
			DataCenter.chatData:setRedDotList(tonumber(self._data.data.role_id), false);
			Lua_MsgUtil.callFunc("UPDATE_SOCIAL_REDDOT");
		end
	elseif self._data.type == 3 then
		if enemyRedDotList[tonumber(self._data.data.role_id)] ~= nil and enemyRedDotList[tonumber(self._data.data.role_id)] == true then
			DataCenter.friendData:setEnemyRedDot(tonumber(self._data.data.role_id), false);
			Lua_MsgUtil.callFunc("UPDATE_SOCIAL_REDDOT");
		end
	end
	Lua_MsgUtil.callFunc("FRIEND_SENDNEW_DATA", self._data);
end

function Lua_FriendItem:onHeadImgClick(go)
	if self._data.type == 2 then
		self.isMyFriend = true;
		self.isMyBlack = false;
	elseif self._data.type == 4 then
		self.isMyFriend = false;
		self.isMyBlack = true;
	else
		self.isMyFriend = false;
		self.isMyBlack = false;
	end
	Lua_ChatUtil.playerMenuPopListShow({role_id = tonumber(self._data.data.role_id), team = tonumber(self._data.data.team_status), 
	league_name = self._data.data.league_name,name = self._data.data.name}, self.isMyFriend, self.isMyBlack);
end

function Lua_FriendItem:onHeartSpClick()
	local isMyPartner = DataCenter.marryData:chaeckIsMyPartner(self._data.data.role_id);
	if isMyPartner == false then
		Lua_WindowUtil.openWin("Lua_NoSpouseIntimacyTipsWindow", WinParam.ACTION_OPEN, self._data.data.intimacy);
	else
		Lua_WindowUtil.openWin("Lua_SpouseIntimacyTipsWindow", WinParam.ACTION_OPEN, nil);
	end
end