Lua_RecommendItem = class("Lua_RecommendItem", Lua_ListCell);
function Lua_RecommendItem:ctor(p)
	self:superCall("ctor", p, "RecommendItem_skin");
end

function Lua_RecommendItem:buildShowItem()
	self:superCall("buildShowItem");
    self.headImg:SetDimensions(78, 78)
end

function Lua_RecommendItem:setData(data)
    self._data=data
    self.nameTxt.text=data.name
    self.addSp:setAltas("common_atlas_2", "ui_common_btn_12");
    self.addSp:addClickFuntion(self,self.onAddSpClick);
    if isHeadReplaceOpen() then
        local isDefault = DataCenter.roleData:isDefaultHead(data.career, data.role_head_name);
        if isDefault then
            self.headImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom( data.role_head_name, 1));
        else
            self.headImg:setUrl(data.role_head_name, 99, true);
            self.headImg:setRoundSize(0, 0.5, 0.5, 0.25);
        end
    else
    	self.headImg:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(data.career, data.profession));
    end
    if data.vip_status < 10 then
        local vipStr = "fvip_";
        self.vip:setAltas("number_atlas", vipStr .. data.vip_status);
    else 
        if data.vip_status == 100 then
            self.vip:setAltas("number_atlas", "fvip_+");
        else
            local vipStr = string.split(data.vip_status, " ");
            self.vip:setAltas("number_atlas", "fvip_" .. vipStr[1]);
            self.vip2=UICreate.createUIAtlasImage(self.content, "number_atlas", "fvip_" .. vipStr[2], -27, -14, 14, 22);
        end
        
    end
    self.lvTxt.text=LanUtil.formateStr(LanUtil.getValue(120111), tostring(data.level))
end

function Lua_RecommendItem:onAddSpClick(go)
    local cfg = getConfig({"func_open",10022});
    if cfg ~= nil and self._data.level >= cfg.cond_level then
        self:updateAddSp();
    end
    DataCenter.friendData:sAddFriendRequest(self._data);
end

function Lua_RecommendItem:updateAddSp()
    self.addSp:setAltas("common_atlas_1", "ui_common_xz");
    self.addSp:setSacle(1, 1, 1);
    self.addSp:removeClickFuntion(self, self.onAddSpClick);
    self.addSp.clickScale = false;
end
